package com.lefishy.remembrance;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;


public abstract class Entity {
	
	protected Vector2 position;
	protected float[] shape;
	protected int colour;
	public Vector2 nextDirection;
	
	public abstract void update();
	
	public Entity()
	{
		position = new Vector2(0,0);
		float[] newShape = {-.5f,-.5f,-.5f,.5f,.5f,.5f,.5f,-.5f};
		shape = newShape.clone();
		colour = Color.CYAN;
	}
	
	public void setColour(int colour)
	{
		this.colour = colour;
	}
	
	public void setPosition(Vector2 pos)
	{
		position = pos;
	}
	
	public void setPosition(int x, int y)
	{
		position = new Vector2(x, y);
	}
	
	public Vector2 getPosition()
	{
		return position;
	}
	
	public void render(Canvas canvas)
	{
		Paint myPainter = new Paint();
		myPainter.setStyle(Paint.Style.STROKE);
		myPainter.setColor(colour);
		//myPainter.setStrokeWidth(3);
		//myPainter.setStrokeJoin(Paint.Join.ROUND);
		float[] drawPoints = new float[shape.length];
		for(int i = 0; i< drawPoints.length;i++)
		{
			if(i % 2 == 0)
			{
				drawPoints[i] = (float) (shape[i] + position.getX());
			}
			else
			{
				drawPoints[i] = (float) (shape[i] + position.getY());
			}
		}
		canvas.drawLines(drawPoints, myPainter);
	}

}
