package com.lefishy.remembrance;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.util.Log;
import android.view.KeyEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class Main extends SurfaceView implements SurfaceHolder.Callback {
	
	public DrawThread thread;
	public String GameState = "GAME";
	
	public Main(Context context) {
		super(context);
		getHolder().addCallback(this);
		thread = new DrawThread(getHolder(), this);
		currentScene = new Game();
	}

	private Scene currentScene;
	
	public void update()
	{
		//Log.d("moo", "cow");
		currentScene.update();
	}
	
	public void onDraw(Canvas canvas)
	{
		canvas.drawColor(Color.BLACK);
		currentScene.render(canvas);
	}
	
	
	public void surfaceCreated(SurfaceHolder holder)
	{
		thread.setRunning(true);
		thread.start();
	}
	
	public void surfaceDestroyed(SurfaceHolder holder)
	{
		boolean retry = true;
		thread.setRunning(false);
		while(retry){
			try
			{
				thread.join();
				retry = false;
			}
			catch (InterruptedException e)
			{
				
			}
		}
	}
	
	class DrawThread extends Thread
	{
		private SurfaceHolder surfaceHolder;
		private Main main;
		private boolean running = false;
		
		public DrawThread(SurfaceHolder surfaceHolder, Main main)
		{
			this.surfaceHolder = surfaceHolder;
			this.main = main;
		}
		
		public void setRunning(boolean run)
		{
			running = run;
		}
		
		public void run()
		{
			Canvas c;
			while(running)
			{
				c = null;
				try
				{
					sleep(40);
					c = surfaceHolder.lockCanvas(null);
					synchronized(surfaceHolder)
					{
						main.update();
						main.onDraw(c);
					}
					
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
				}
				finally
				{
					if(c != null)
						surfaceHolder.unlockCanvasAndPost(c);
				}
			}
		}
	}

	@Override
	public void surfaceChanged(SurfaceHolder holder, int format, int width,
			int height) {
		// TODO Auto-generated method stub
		
	}
	
	public boolean onKeyDown(int keyCode, KeyEvent msg)
	{
		Log.d("moo","cow");
		
		if(GameState == "GAME")
		{
			if(keyCode == KeyEvent.KEYCODE_DPAD_UP)
				currentScene.player.nextDirection = new Vector2(0,-1);
			if(keyCode == KeyEvent.KEYCODE_DPAD_DOWN)
				currentScene.player.nextDirection = new Vector2(0,1);
			if(keyCode == KeyEvent.KEYCODE_DPAD_LEFT)
				currentScene.player.nextDirection = new Vector2(-1,0);
			if(keyCode == KeyEvent.KEYCODE_DPAD_RIGHT)
				currentScene.player.nextDirection = new Vector2(1,0);
		}
		
		return false;
	}

}
