package com.lefishy.remembrance;

import android.graphics.Canvas;

public abstract class Scene {
	
	private Entity[] children = new Entity[0];
	public Entity player;

	public void update() {
		for(Entity e : children)
		{
			e.update();
		}
		
	}

	public void render(Canvas canvas) {
		for(Entity e : children)
		{
			e.render(canvas);
		}
		
	}
	
	public void addEntity(Entity e)
	{
		Entity newObjects[] = new Entity[children.length+1];
		for(int i = 0;i<children.length+1; i++)
		{
			if(i == children.length)
				newObjects[i] = e;
			else
			{
				newObjects[i] = children[i];
			}
		}
		children = newObjects.clone();
	}

}
